local fun = {}

function fun.id(...) return ... end

function fun.listMap(f, ...)
	local lists = {...}
	if #lists == 0 then
		return {}
	end
	local n = #lists[1]
	for _, l in ipairs(lists) do
		n = math.min(n, #l)
	end
	local res = {}
	local args = {}
	for i = 1, n do
		for j = 1, #lists do
			args[j] = lists[j][i]
		end
		res[i] = f(unpack(args))
	end
end

fun.operators = {
	dual = {
		add = function(a, b)
			return a + b
		end,
		sub = function(a, b)
			return a - b
		end,
		mul = function(a, b)
			return a * b
		end,
		div = function(a, b)
			return a / b
		end,
		mod = function(a, b)
			return a % b
		end,
		concat = function(a, b)
			return a .. b
		end,
	},
	unary = {
		unm = function(a)
			return -a
		end,
		len = function(a)
			return #a
		end,
	},
}

return fun
